*===========================================================================
* Function...: CreateParameterObject
* Author.....: Mark Austen
* Date.......: November 10, 2001 
* Notice.....: Copyright (c)  Schooner Software Limited,
* ...........: All Rights Reserved.
* Abstract...: Creates a very lightweight parameter object.
*===========================================================================
*
function CreateParameterObject( pcValueList as string, pcFieldList as string )
*
local ;
  loParam, ;
  lnI, ;
  lcField, ;
  luValue, ;
  QQ___QQ
*
loParam = newobject( 'Relation' )
*
with loParam
  *
  for lnI = 1 to occurs( ',', pcFieldList ) + 1
    lcField = GetItem( pcFieldList, lnI )
    luValue = GetItem( pcValueList, lnI )
    *
    if not empty( luValue )
      .AddProperty( lcField, evaluate( luValue ))
      *
    else && not empty( luValue )
      .AddProperty( lcField )
      *
    endif && not empty( luValue )
    *
  next && lnI
  *
endwith && loParam
*
return loParam
*
*===========================================================================
* End: CreateParameterObject
*===========================================================================
