*===========================================================================
* Function...: GetItem
* Author.....: Mark Austen
* Date.......: November 10, 2001 
* Notice.....: Copyright (c)  Schooner Software Limited,
* ...........: All Rights Reserved.
* Abstract...: Returns an element from a delimited list.
*===========================================================================
*
function GetItem( ;
  pcList      as string, ;
  pnIndex     as integer, ;
  pcDelimiter as string )
*
if empty( pcList )
  return ''
  *
endif && empty( pcList )
*
if pnIndex < 0
  return ''
  *
endif && pnIndex < 0
*
local ;
  lcDelimiter
*
lcDelimiter = iif( pcount() > 2, pcDelimiter, ',' )
*
if pnIndex > occurs( lcDelimiter, pcList ) + 1
  return ''
  *
endif && pnIndex > occurs( lcDelimiter, pcList ) + 1
*
local ;
  lcValue, ;
  lclist, ;
  QQ___QQ
*
lcList  = lcDelimiter + alltrim( pcList ) + lcDelimiter
lcValue = strextract( lcList, lcDelimiter, lcDelimiter, pnIndex )
*
return lcValue
*
*===========================================================================
* End: GetItem
*===========================================================================
