*==========================================================================
*-- Title......: LogAction
*-- Version....: 1.0 A
*-- Author.....: Mark Austen
*--            : ( c ) 1999 by Schooner Software Limited
*-- Date.......: February 11, 1999
*-- Abstract...: Log action to a text file
*-- Parameters.: Action to log
*-- History....: 1.0 A Initial Version
*==========================================================================
*
# define LOG_FILE 'Action.txt'
*
procedure LogAction
*
parameters ;
  pcAction, ;
  plErase
*
local ;
  lcHome, ;
  lnHandle
*
lcHome = AddBS( GetHome() )
*
if plErase
  erase ( lcHome + LOG_FILE )
  *
endif && plErase
*
if file( lcHome + LOG_FILE )
  lnHandle = fopen( lcHome + LOG_FILE, 1 )
  *
else
  lnHandle = fcreate( lcHome + LOG_FILE )
  *
endif
*
if lnHandle > -1
  = fseek( lnHandle, 0, 2 )
  = fputs( lnHandle, pcAction )
  = fclose( lnHandle )
  *
endif
*
return
*
*
