lparameters ;
  tcID, ;
  tcName, ;
  tcClass, ;
  tlInit
*
local ;
  lnSelect, ;
  llOpened, ;
  lcID, ;
  lnStack, ;
  lcName, ;
  lnLen, ;
  lnI, ;
  lcModule

* Open or create the log file.

lnSelect = select()
do case
  case not file('LOG.DBF')
    create ;
      table ;
        LOG ;
      free ;
      ( ;
        ID C(10), ;
        NAME C(40), ;
        CLASS C(40), ;
        INSTFROM C(128), ;
        INIT L, ;
        DESTROY L ;
      )
    index on ID tag ID
    llOpened = .T.
  case not used('LOG')
    select 0
    use LOG order ID again
    llOpened = .T.
  otherwise
    select LOG
    set order to ID
endcase

* If this is an instantiation, figure out where the object was instantiated
* from. Start from the method that called us, and work back.

lcID = lower(tcID)
do case
  case tlInit
    lnStack = program(-1) - 1
    lcName  = upper(tcName) + '.'
    lnLen   = len(lcName)
    for lnI = lnStack to 1 step -1
      lcModule = program(lnI)
      if left(lcModule, lnLen) = lcName
        lcModule = program(lnI - 1)
        if lcModule = 'MAKEOBJECT'
          lcModule = program(lnI - 2)
        endif lcModule = 'MAKEOBJECT'
        exit
      endif left(lcModule, lnLen) = lcName
    next lnI
    insert ;
      into ;
        LOG ;
      values ;
      ( ;
        lcID, ;
        lower(tcName), ;
        lower(tcClass), ;
        lcModule, ;
        .T., ;
        .F. ;
       )

* This is a destroy, so try to find the existing record in the log and update
* it.

  case seek(lcID)
    replace DESTROY with .T.
endcase

* Clean up and exit.

if llOpened
  use in LOG
endif llOpened
select (lnSelect)
