***********************************************************************
* Program....: CLEANADDRESSES.PRG
* Date.......: 30 November 2002
* Notice.....: Copyright (c) 2002 Tightline Computers, Inc
* Compiler...: Visual FoxPro 08.00.0000.2319 for Windows 
* Purpose....: Illustrate the use of the Address Parser
***********************************************************************
*** Make sure nothing is open
CLOSE TABLES
*** Turn off buffering
CURSORSETPROP("Buffering", 1, 0)
*** Open the destination table and clear it
SELECT 0
USE addresses EXCLUSIVE
ZAP IN addresses
*** Open up the original source table
SELECT 0
USE namefile
*** And populate the address table
SCAN
  INSERT INTO addresses (iscepk, msource ) ;
       VALUES (namefile.ipsnpk, namefile.maddress )
ENDSCAN
*** Close original file
USE IN namefile
SELECT addresses
*** Create the parser
loParser = NEWOBJECT( 'addressparser', 'addparse.prg' )
SCAN
  *** Get the parsed out address
  loAddr = loParser.ParseAddress( addresses.msource )
  WITH loAddr
    IF .lSuccess
      *** We got an address back
      REPLACE caddr1 WITH .caddr1, ; 
              caddr2 WITH .caddr2, ; 
              czip WITH .czip, ; 
              ccity WITH .ccity, ; 
              cstate WITH .cstate, ; 
              cluzip WITH .cluzip, ; 
              clucity WITH .clucity, ; 
              clustate WITH .clustate IN addresses
    ELSE
      *** Do nothing
    ENDIF
  ENDWITH
ENDSCAN
*** See the results      
BROWSE LAST



  
  

